import numpy as np
from .Track import Track

# Track descriptor information:
# 0 - straight, 1 - corner
# 0 - left, 1 - right
# [type,length/sweep,radius,direction]

segments = np.array(
    [
        [0, 150, 0, -1],
        [1, np.pi / 2, 50, 0],
        [0, 100, 0, -1],
        [1, np.pi / 2, 90, 0],
        [0, 300, 0, -1],
        [1, np.pi / 2, 50, 0],
        [0, 100, 0, -1],
        [1, np.pi / 2, 90, 0],
        [0, 155, 0, -1],
    ]
)
ovaltrack = Track(segments)

segments = np.array(
    [
        [0, 550, 0, -1],
        [1, 2.7, 12, 1],
        [0, 300, 0, -1],
        [1, 0.2, 160, 1],
        [0, 340, 0, -1],
        [1, 0.3, 120, 0],
        [0, 40, 0, -1],
        [1, 0.8, 120, 1],
        [0, 40, 0, -1],
        [1, 0.4, 120, 0],
        [0, 260, 0, -1],
        [1, 0.4, 160, 1],
        [0, 750, 0, -1],
        [1, 1.2, 30, 1],
        [0, 30, 0, -1],
        [1, 1.1, 40, 0],
        [0, 80, 0, -1],
        [1, 1.4, 55, 1],
        [0, 310, 0, -1],
        [1, 3.14, 55, 1],
        [0, 140, 0, -1],
        [1, 1.45, 50, 0],
        [0, 440, 0, -1],
        [1, 1.4, 70, 0],
        [0, 60, 0, -1],
        [1, 1.2, 130, 0],
        [0, 340, 0, -1],
        [1, 1.45, 66, 1],
        [0, 60, 0, -1],
        [1, 1.35, 66, 0],
        [0, 200, 0, -1],
        [1, 1.57, 50, 1],
        [0, 140, 0, -1],
        [1, 1.6, 140, 1],
        [0, 200, 0, -1],
        [1, 0.7, 150, 1],
        [0, 270, 0, -1],
        [1, 0.5, 160, 0],
        [0, 220, 0, -1],
        [1, 1.1, 140, 0],
        [0, 481.920, 0, -1],
        [1, 1.90, 10, 1],
        [0, 23.9815, 0, -1],
        [1, 1.94, 17, 0],
    ]
)
Spa = Track(segments)

segments = np.array(
    [
        [0, 927, 0, -1],
        [1, 1.48, 40, 1],
        [0, 32, 0, -1],
        [1, 1.04, 50, 0],
        [0, 87, 0, -1],
        [1, 1.10, 104, 1],
        [0, 30, 0, -1],
        [1, 1.60, 150, 1],
        [0, 263, 0, -1],
        [1, 1.48, 44, 1],
        [0, 10, 0, -1],
        [1, 1.56, 100, 1],
        [0, 177, 0, -1],
        [1, 2.54, 42, 0],
        [0, 130, 0, -1],
        [1, 0.55, 150, 0],
        [0, 115, 0, -1],
        [1, 1.48, 52, 0],
        [0, 45, 0, -1],
        [1, 0.4, 100, 1],
        [0, 181, 0, -1],
        [1, 1.72, 85, 1],
        [0, 505, 0, -1],
        [1, 2.60, 34, 0],
        [0, 100, 0, -1],
        [1, 0.8, 30, 0],
        [0, 10, 0, -1],
        [1, 3.20, 60, 1],
        [0, 135, 0, -1],
        [1, 1.40, 30, 1],
        [0, 100, 0, -1],
        [1, 1.65, 25, 0],
        [0, 10, 0, -1],
        [1, 1.50, 33, 1],
        [0, 74.84, 0, -1],
        [1, 1.503, 90, 1],
        [0, 142.0, 0, -1],
    ]
)
Barcelona = Track(segments)

segments = np.array(
    [
        [0, 483.85, 0, -1],
        [1, 1.50, 20, 1],
        [0, 367, 0, -1],
        [1, 2.3, 92, 0],
        [0, 40, 0, -1],
        [1, 1.75, 30, 1],
        [0, 161, 0, -1],
        [1, 2.4, 25, 1],
        [0, 10, 0, -1],
        [1, 0.4, 30, 0],
        [0, 60, 0, -1],
        [1, 3.2, 11, 0],
        [0, 55, 0, -1],
        [1, 1.6, 17, 1],
        [0, 52, 0, -1],
        [1, 1.9, 17, 1],
        [0, 180, 0, -1],
        [1, 1.05, 160, 1],
        [0, 100, 0, -1],
        [1, 0.4, 150, 1],
        [0, 100, 0, -1],
        [1, 1.54, 12, 0],
        [0, 1, 0, -1],
        [1, 1.54, 12, 1],
        [0, 20, 0, -1],
        [1, 0.9, 30, 1],
        [0, 1, 0, -1],
        [1, 0.9, 40, 0],
        [0, 140, 0, -1],
        [1, 1.5, 40, 0],
        [0, 111, 0, -1],
        [1, 1.0, 40, 0],
        [0, 1, 0, -1],
        [1, 0.90, 40, 1],
        [0, 125, 0, -1],
        [1, 1.4, 20, 1],
        [0, 1, 0, -1],
        [1, 1.5, 30, 0],
        [0, 92, 0, -1],
        [1, 0.7, 70, 0],
        [0, 44, 0, -1],
        [1, 2.6, 18, 1],
        [0, 40, 0, -1],
        [1, 1.4, 30, 1],
        [0, 5, 0, -1],
        [1, 0.4, 20, 0],
        [0, 51.6, 0, -1],
        [1, 0.4, 80, 1],
    ]
)
Monaco = Track(segments)

segments = np.array(
    [
        [0, 1042, 0, -1],
        [1, 1.54, 16, 1],
        [0, 15, 0, -1],
        [1, 1.80, 19, 0],
        [0, 101, 0, -1],
        [1, 0.26, 140, 1],
        [0, 102, 0, -1],
        [1, 1.40, 200, 1],
        [0, 400, 0, -1],
        [1, 1.30, 15, 0],
        [0, 19, 0, -1],
        [1, 1.20, 15, 1],
        [0, 280, 0, -1],
        [1, 1.70, 67, 1],
        [0, 226, 0, -1],
        [1, 1.30, 40, 1],
        [0, 285, 0, -1],
        [1, 0.25, 160, 0],
        [0, 441, 0, -1],
        [1, 1.1, 28, 0],
        [0, 40, 0, -1],
        [1, 0.99, 86, 1],
        [0, 20, 0, -1],
        [1, 0.8, 35, 0],
        [0, 921.55, 0, -1],
        [1, 1.56, 70, 1],
        [0, 0.13, 0, -1],
        [1, 1.58, 200, 1],
    ]
)
Monza = Track(segments)

segments = np.array([[0, 200, 0, -1], [1, np.pi / 2, 20, 1], [0, 200, 0, -1]])
singleturn = Track(segments)

segments = np.array(
    [
        [0, 60, 0, -1],
        [1, np.pi / 2, 30, 1],
        [0, 60, 0, -1],
        [1, np.pi / 2, 100, 0],
        [0, 60, 0, -1],
    ]
)
doubleturn = Track(segments)

segments = np.array([[0, 120, 0, -1], [1, np.pi, 30, 1], [0, 120, 0, -1]])
uturn = Track(segments)

segments = np.array(
    [
        [0, 150, 0, -1],
        [1, np.pi / 4, 50, 0],
        [0, 10, 0, -1],
        [1, np.pi / 4, 50, 1],
        [0, 50, 0, -1],
        [1, np.pi, 25, 0],
        [0, 100, 0, -1],
    ]
)
multiturn = Track(segments)

segments = np.array([[0, 100, 0, -1]])
straight = Track(segments)

segments = np.array(
    [
        [0, 450, 0, -1],
        [1, np.deg2rad(133), 17, 1],
        [0, 67, 0, -1],
        [1, np.deg2rad(64), 21, 0],
        [0, 80, 0, -1],
        [1, np.deg2rad(28.6), 90, 1],
        [0, 530, 0, -1],
        [1, np.deg2rad(117), 35, 1],
        [0, 1, 0, -1],
        [1, np.deg2rad(25), 150, 1],
        [0, 1, 0, -1],
        [1, np.deg2rad(16), 100, 0],
        [0, 120, 0, -1],
        [1, np.deg2rad(30), 100, 0],
        [0, 20, 0, -1],
        [1, np.deg2rad(82.5), 58, 1],
        [0, 55, 0, -1],
        [1, np.deg2rad(60), 60, 0],
        [0, 198, 0, -1],
        [1, np.deg2rad(150), 20, 1],
        [0, 300, 0, -1],
        [1, np.deg2rad(60), 95, 0],
        [0, 28, 0, -1],
        [1, np.deg2rad(121), 15, 0],
        [0, 120, 0, -1],
        [1, np.deg2rad(5.35), 120, 0],
        [0, 553, 0, -1],
        [1, np.deg2rad(80), 35, 0],
        [0, 1, 0, -1],
        [1, np.deg2rad(83), 135, 0],
        [0, 60, 0, -1],
        [1, np.deg2rad(98), 125, 1],
        [0, 107, 0, -1],
        [1, np.deg2rad(30), 70, 1],
        [0, 20, 0, -1],
        [1, np.deg2rad(93.5), 40, 1],
        [0, 735, 0, -1],
        [1, np.deg2rad(100), 30, 1],
        [0, 47.3, 0, -1],
        [1, np.deg2rad(21.5), 80, 1],
        [0, 645.2, 0, -1],
    ]
)
Bahrain = Track(segments)

segments = np.array(
    [
        [0, 450, 0, -1],
        [1, np.deg2rad(133), 17, 1],
        [0, 67, 0, -1],
        [1, np.deg2rad(64), 21, 0],
        [0, 80, 0, -1],
        [1, np.deg2rad(28.6), 90, 1],
        [0, 530, 0, -1],
        [1, np.deg2rad(112), 35, 1],
        [0, 70, 0, -1],
        [1, np.deg2rad(60), 65, 0],
        [0, 125, 0, -1],
        [1, np.deg2rad(71), 150, 1],
        [0, 15, 0, -1],
        [1, np.deg2rad(80), 30, 0],
        [0, 20, 0, -1],
        [1, np.deg2rad(68.1), 35, 1],
        [0, 150, 0, -1],
        [1, np.deg2rad(30), 100, 1],
        [0, 717, 0, -1],
        [1, np.deg2rad(100), 30, 1],
        [0, 46, 0, -1],
        [1, np.deg2rad(21.03), 80, 1],
        [0, 646.8, 0, -1],
    ]
)
Bahrain_short = Track(segments)

segments = np.array(
    [
        [0, 400, 0, -1],
        [1, np.deg2rad(95), 30, 1],
        [0, 180, 0, -1],
        [1, np.deg2rad(58), 65, 1],
        [0, 65, 0, -1],
        [1, np.deg2rad(92), 115, 0],
        [0, 20, 0, -1],
        [1, np.deg2rad(27), 350, 1],
        [0, 170, 0, -1],
        [1, np.deg2rad(80), 20, 1],
        [0, 18, 0, -1],
        [1, np.deg2rad(110), 20, 0],
        [0, 75, 0, -1],
        [1, np.deg2rad(185), 30, 1],
        [0, 1150, 0, -1],
        [1, np.deg2rad(115), 20, 1],
        [0, 32, 0, -1],
        [1, np.deg2rad(90), 22, 0],
        [0, 10, 0, -1],
        [1, np.deg2rad(45.2), 320, 1],
        [0, 300, 0, -1],
        [1, np.deg2rad(14), 500, 1],
        [0, 220, 0, -1],
        [1, np.deg2rad(103), 17, 1],
        [0, 28, 0, -1],
        [1, np.deg2rad(70), 29, 0],
        [0, 14, 0, -1],
        [1, np.deg2rad(83.5), 20, 1],
        [0, 105, 0, -1],
        [1, np.deg2rad(97), 20, 1],
        [0, 230, 0, -1],
        [1, np.deg2rad(41), 80, 0],
        [0, 100, 0, -1],
        [1, np.deg2rad(45), 65, 0],
        [0, 90, 0, -1],
        [1, np.deg2rad(94), 15, 0],
        [0, 85, 0, -1],
        [1, np.deg2rad(83), 25, 1],
        [0, 80, 0, -1],
        [1, np.deg2rad(80), 20, 1],
        [0, 30, 0, -1],
        [1, np.deg2rad(16), 90, 1],
        [0, 196, 0, -1],
        [1, np.deg2rad(70), 40, 0],
        [0, 140, 0, -1],
        [1, np.deg2rad(20), 50, 0],
        [0, 23, 0, -1],
        [1, np.deg2rad(90), 25, 0],
        [0, 110, 0, -1],
    ]
)
AbuDhabi = Track(segments)
